If you are beginner in graph, watch his videos twice or thrice because then you will feel like no one can explain better than him and you will understand each and every point mentioned in the video. Thank you Sir for this playlist.
A lot of you are asking about how to reconstruct the path, so let me just explain it here. To reconstruct the path from the start to the end you need to maintain additional information, namely a 2D matrix which tracks the cell which was used to reach the current cell. Let me call this matrix "prev", short for previous. Every time you advance to the next cell, keep track of which cell you came from in the prev matrix. Once you reach the end of the BFS, start reconstructing the path by beginning at the end node in the prev matrix and work your way to the start node. The obtained path will be in reverse order, so you will need to reverse it. This is explained in more detail in the BFS video except that the prev matrix is 1D for the general case: ruclips.net/video/oDqjPvD54Ss/видео.html
@@austind649 Hi Austin, whenever we reach a '#' cell, that cell can not be visited as it's an obstacle so can not be in our path. so we don't need to process it and we need to find another path through a reachable cell. The whole point here is only go through the path that is reachable.
@@ss4036 Here is my code in C++, implemented by the williamfiset approach, which stores the the path and also shows BFS path taken in the matrix. pastebin.com/TeMDhspF
Hi, what about if you can move diagonally? Mine calculates the distance correctly and I had the path reconstruction working for the cardinal directions but once I add diagonal vectors then the path reconstruction works strangely. I know its probably hard to say without looking at my code but how do you modify the above algorithm to account for diagonal? Or should it "just work" if you add the new vectors?
This is probably one of the most helpful 'Algorithms & Data Structures' channels I've yet encountered. The idea of maintaining multiple queues for each dimension is really handy.
Can you please explain why its better to have separate queues for each dimension? I cant see how its better than having one queue with the dimensions encapsulated into one object..
@@alikhansmt It's just a personal preference of mine. I've found this approach quicker to implement, and reuse over larger code structures, where I don't like to maintain a vast amount of structs, dot callbacks etc... Speaking in terms of competitive programming of course.
I was hammering about how to solve these ki9nd of problems. You are a savior! Please make these kind of tutorials more. I cannot thank you enough. Subscribed!
An alternative to using 'nodes_left_in_layer' and 'nodes_in_next_layer' variables is to store the distance/level along with the coordinates into your queue. It does have the downside of using an Object or Array to hold the coordinates and the level, but is easier to understand.
Your videos are amazing, but there is one possible improvement: run through the pseudo-code with the animation for the algorithm, so visualizing the pseudo-code becomes easier
this is exactly what i needed to know to solve graph problems, thanks for the video :) watching your tutorial for the first time, should have watched it earlier.
Amazing explanation, thanks for the video! I've been always avoiding BFS and going with DFS since I wasn't comfortable with it, but not anymore! Subscribed to your channel... Will be waiting for more tutorials from you!
Very clear approach! Just would like to share something regarding using 2 queues for 2D Matrixes, it just affects the performance very badly single Queue implementation is much more efficient. Other than this, great explanation thanks.
Brilliant video, thank you so much for these. I think you could also modify solve() to return a prev collection as in the BFS Shortest Path video, and add the end cell coordinates or marker character ('E') as a parameter to the enclosing function. Then you no longer need all the global counting variables (nodes_left_in_layer etc). You would need to perform [number of steps in shortes path] iterations over prev to get the shortest path and return shortest_path.size() - 1. Maybe not optimal since you have to iterate over the shortest path too, but as long as you still break inside solve() when reached_end = True, the time complexity should stay the same.
Good stuff, for my dumb brain it wasn't clear in the first glance why we needed the nodes_in_next_layer and nodes_left_in_layer and how it's used. Had to replay and follow through the algorithm to understand its use.
Try to think this way: BFS is visiting graph layer by layer. Initially the nodes_left_in_layer = 1; supposed that there're 2 adjacent nodes (A, B)connecting the starting node(S), so the nodes_in_next_layer will be incremented to 2 after the explorer_neighbours(), then the nodes_left_in_layer is decremented to 0. Here, we reset the nodes_left_in_layer to 2 and nodes_in_next_layer to 0 and increment the move_count to 1. It means after visiting layer 1, we are expecting to visit 2 nodes in layer 2. We can image node A has 3 adjacent nodes (C, D, E) and node B has 1 adjacent nodes (F). Now try to go-thru layer 2 with the imaginary graph - we visit A, nodes_in_next_layer is set to 3, nodes_left_in_layer is set to 1, then visit B, nodes_in_next_layer is set to 4 and nodes_left_in_layer to 0. Here, we are finishing visit layer 2 and expecting to visit layer 3 with 4 coming nodes. snap shots of queue: (S) (A) (B) // nodes_in_next_layer = 2, after visiting layer 1; (B) (C) (D) (E) // pop (A) and push all neighbours (C) (D) (E) (C) (D) (E) (F) // pop (B) and push neighbour (E) // nodes_in_next_layer = 4, after visiting layer 2; Hope this helps.
i think level would be better name compared to layer as BFS processes nodes which are at same level/distance from current node. Once we process all the nodes in current level, we move onto the next level. BFS is also called commonly referred to as level order traversal
@@jsarvesh yea, level is a much better name. I also find easier to code and understand passing an additional information into the object/struct of the queue, that is the level so when i push neighbors to the queue i increment this level/distance like this: q.push((position){.level=nextLevel, .row=nextRow, .col=nextCol, .distance=pos.distance + 1});
I also use two int arrays instead of an array of int,int objects. Before I was shy to tell about it because it is "not OOP". Now my design is backed by this video.
Thanks for the multiple queue trick. Storing them as pairs does not scale well to higher dimensions and p.first and p.second looks really ugly and ambiguous.
I created a ArrayList variable to store the steps taken, but it store all the block the BFS explored instead of the green block that shown in the video. How can I only store the shortest block need to be explored only?
What about the Robot Vacuum Cleaner problem, a double array 3x3 a robot is somewhere in the grid and in some cells there is dirt and the robot must find the optimal path in order to clean the cells and doing that with the BFS algorithm. Any suggestions?
Am I the only one who missed the part where we select the path that he colored in green? What's explained in this video only shows how many steps we need to reach the end, but not the actual path.
11:16 does this pseudo code applies for a 3d grid graph? im confused you mention to use 3 queues for 3ds grid graph and then went straight back to 2d pseudo code
can someone please help me understand, why is it we choose BFS over DFS to find "shortest path" ? i believe it has to be the way BFS traverses a graph as compared to DFS, but looking for a better explanation
Hi, I have a (maybe so stupid question). BFS cannot use as a shortest path finding with weighted graph right? (it just work with unweight - or all the edge have the same priority). I am not sure about this because at the video Overview, you said it can be use as shortest path finding algorithms. (But to my knowlege, it is impossible). Maybe i got mistake, thanks.
Hi William, shouldn't the move count be move_count+1(if reached_end is true) as we are breaking the loop and not incrementing move_count for the last layer(where end node was found)?
Looking at the order of direction vectors which is (-1,0), (+1,0), (0,+1), (0, -1)...it looks like you are interested to move row wise first and then column wise. Then how does it become breadth first algorithm. As BFA says, we to move across the row first right.
Hi Shiva, it doesn't matter which direction vector is applied first because you're doing the BFS layer by layer and adding newly discovered nodes to the end of the queue.
That's exactly is my question.. how does this approach taking breadth first. With the use of vectors we go on finding the next node to traverse and looking at the these vectors, traversing need not be breadth wise. Because you are looking for next node above and below the current node first. I hope it makes sense.
Let me try and make this as clear as possible. For any given node, we add all the neighbors of that node to the list of nodes that need to be visited (unless the neighboring node has already been visited, is not traversable or something weird). The list of nodes to be visited is stored in a queue data structure. The queue has the property that the most recent node added to the queue is found at the end and the oldest node which has been in the queue the longest at the beginning. This means that we can add nodes to the queue and know that they will eventually get processed at a later stage. When the BFS starts you add the starting node to the queue to indicate that it should be visited. The algorithm begins by dequeuing (removing) the start node from the beginning of the queue, after which you add the left, right, down and up neighbors of the start node to the queue in that order (which shouldn't matter). Then the starting node's left node is first in the queue, so you add its left, right, down and up neighbors to the queue, then the starting node's right node if first in the queue, so you add its left, right, down and up neighbors to the queue, and etc... So the algorithm circles around if you will and the graph is explored layer by layer
If you are beginner in graph, watch his videos twice or thrice because then you will feel like no one can explain better than him and you will understand each and every point mentioned in the video. Thank you Sir for this playlist.
Finally, i'm waiting for this kind of tutorial
You're great dude
YOU ARE A LIFE SAVER I COULD NEVER FIND A VIDEO LIKE THIS THANK YOU SO MUCH FOR THE GIFT YOUVE BESTOWED UPON THIS LAND
I rewrote your pseudocode in JavaScript adjusted it a bit to suit my needs. Worked perfectly right out of the box! Awesome work, William!
Can you share it?
@@saiffyros
// ruclips.net/video/KiCBXu4P-2Y/видео.html
// Globals
// number of rows and columns
const R = 10;
const C = 14;
// start cell values
const sr = 4;
const sc = 0;
// row and column queue
const rq = [];
const cq = [];
// save the directions found
const dir = [];
// variables to track the steps taken
let move_count = 0;
let nodes_left_in_layer = 1;
let nodes_in_next_layer = 0;
// variable to check if we've reached the end
let reached_end = false;
const map = {
cols: 14,
rows: 10,
sSize: 64,
tsize: 40
}
const gameGrid = [
[ 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 9, 0],
[ 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 0],
[ 0, 0, 1, 1, 1, 1, 0, 0, 0, 0, 0, 0, 1, 0],
[ 0, 0, 1, 0, 0, 1, 0, 0, 1, 1, 1, 1, 1, 0],
[ 8, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, 0],
[ 0, 0, 0, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, 0],
[ 0, 0, 0, 0, 0, 1, 0, 0, 1, 1, 1, 1, 1, 0],
[ 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, 0, 0, 1, 0],
[ 0, 0, 0, 0, 0, 1, 1, 1, 1, 1, 1, 1, 1, 0],
[ 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0]
]
// R x C matrix of false values aka visited positions
const visited = [
[0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0],
[0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0],
[0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0],
[0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0],
[0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0],
[0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0],
[0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0],
[0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0],
[0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0],
[0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0]
]
// north, south, east, west direction vectors
const dr = [ -1, +1, 0, 0];
const dc = [ 0, 0, +1, -1];
function findPath(){
rq.push(sr);
cq.push(sc);
visited[sr][sc] = true;
// Keep going as long as there are items in the queue
while(rq.length > 0 || cq.length > 0){
let r = rq.shift();
let c = cq.shift();
if(gameGrid[r][c] === 'E'){
reached_end = true;
break;
}
check_neighbors( r, c)
nodes_left_in_layer --;
if(nodes_left_in_layer === 0){
nodes_left_in_layer = nodes_in_next_layer;
nodes_in_next_layer = 0;
move_count ++;
}
}
if(reached_end){
return move_count;
}
return -1;
}
function check_neighbors( r, c){
for(let i = 0; i < 4; i++){
let rr = r + dr[i];
let cc = c + dc[i];
//skip out of bounds cells
if(rr < 0 || cc < 0){
continue;
}
if(rr >= R || cc >= C){
continue;
}
// skip blocked or visited cells
if(visited[rr][cc]){
continue;
}
if(gameGrid[rr][cc] === 0){
continue;
}
let move = [dc[i], dr[i]];
dir.push(move);
rq.push(rr);
cq.push(cc);
visited[rr][cc] = true;
nodes_in_next_layer ++;
}
}
findPath();
function getTile(c, r){
return gameGrid[r][c];
}
export { dir, map, getTile };
A lot of you are asking about how to reconstruct the path, so let me just explain it here.
To reconstruct the path from the start to the end you need to maintain additional information, namely a 2D matrix which tracks the cell which was used to reach the current cell. Let me call this matrix "prev", short for previous. Every time you advance to the next cell, keep track of which cell you came from in the prev matrix. Once you reach the end of the BFS, start reconstructing the path by beginning at the end node in the prev matrix and work your way to the start node. The obtained path will be in reverse order, so you will need to reverse it.
This is explained in more detail in the BFS video except that the prev matrix is 1D for the general case: ruclips.net/video/oDqjPvD54Ss/видео.html
Hi William - @14:47, shouldn't we enqueue prior to "continue" on the # equality check? Otherwise certain positions would never be processed.
@@austind649 Hi Austin, whenever we reach a '#' cell, that cell can not be visited as it's an obstacle so can not be in our path. so we don't need to process it and we need to find another path through a reachable cell. The whole point here is only go through the path that is reachable.
Can you please share the code for saving the actual path along with the moves?
@@ss4036 Here is my code in C++, implemented by the williamfiset approach, which stores the the path and also shows BFS path taken in the matrix.
pastebin.com/TeMDhspF
Hi, what about if you can move diagonally? Mine calculates the distance correctly and I had the path reconstruction working for the cardinal directions but once I add diagonal vectors then the path reconstruction works strangely. I know its probably hard to say without looking at my code but how do you modify the above algorithm to account for diagonal? Or should it "just work" if you add the new vectors?
William your explanation and animation creates a clear picture in my head about the underlying Concept, Thanks alot man!
This channel is a gem. very high quality content in these tutorial videos!
This is probably one of the most helpful 'Algorithms & Data Structures' channels I've yet encountered. The idea of maintaining multiple queues for each dimension is really handy.
Can you please explain why its better to have separate queues for each dimension? I cant see how its better than having one queue with the dimensions encapsulated into one object..
@@alikhansmt It's just a personal preference of mine. I've found this approach quicker to implement, and reuse over larger code structures, where I don't like to maintain a vast amount of structs, dot callbacks etc... Speaking in terms of competitive programming of course.
@@brunokawka I see thanks!
Thank you William for the great video. Fellow Canadian here. thank you for the high-quality content!
i love how slow you speak and how thoroughly you explain everything. thanks!
Best explanation for coding problems and approaches!! Thanks for making such high quality content on RUclips
I was hammering about how to solve these ki9nd of problems. You are a savior! Please make these kind of tutorials more. I cannot thank you enough. Subscribed!
An alternative to using 'nodes_left_in_layer' and 'nodes_in_next_layer' variables is to store the distance/level along with the coordinates into your queue.
It does have the downside of using an Object or Array to hold the coordinates and the level, but is easier to understand.
Thanks for this approach! Very intuitive indeed!
This is nice.I have seen this trick used by competitive programmers for traversing in the grid.
What a great tutorial! A great explanation complemented by incredibly clear slides and animations. Thanks.
Thank you so much, William, tons of good information in a very nice format
Your videos are amazing, but there is one possible improvement:
run through the pseudo-code with the animation for the algorithm, so visualizing the pseudo-code becomes easier
Video for visualization!!
Watch till end for better visualization.
Used exactly same concept as explained!!
ruclips.net/video/EdJa84ymIXg/видео.html
this is exactly what i needed to know to solve graph problems, thanks for the video :) watching your tutorial for the first time, should have watched it earlier.
I am preparing for IOI and this video was very Helpful, continue to make great contents like this. Thanks!
My mind is blown at how many things can be modeled as a graph. I go out into the world and just see graphs now.
excellent explanation. I particularly liked your concept for using direction vectors
Great video. thank you very much. This is exactly what I needed to understand how to solve graph problem using adjacency matrix. Thank you once again!
Thanks a lot Will! This is from cracking the coding interview and your walkthrough is well explained. I'm subbing to your channel now
Amazing explanation, thanks for the video! I've been always avoiding BFS and going with DFS since I wasn't comfortable with it, but not anymore! Subscribed to your channel... Will be waiting for more tutorials from you!
This is some of the best fucking content I've ever seen. Absolutely fucking incredible. 10/10 would peek again!
You are just brilliant man! I hope your channel grows big!
really like the summary in the end, as well. it's a nice touch.
Very clear approach! Just would like to share something regarding using 2 queues for 2D Matrixes, it just affects the performance very badly single Queue implementation is much more efficient. Other than this, great explanation thanks.
Efficient in terms of memory complexity, right?
(Because handling so many queues in n-dimensional space would require a lot of memory I presume).
Brilliant video, thank you so much for these.
I think you could also modify solve() to return a prev collection as in the BFS Shortest Path video, and add the end cell coordinates or marker character ('E') as a parameter to the enclosing function. Then you no longer need all the global counting variables (nodes_left_in_layer etc). You would need to perform [number of steps in shortes path] iterations over prev to get the shortest path and return shortest_path.size() - 1.
Maybe not optimal since you have to iterate over the shortest path too, but as long as you still break inside solve() when reached_end = True, the time complexity should stay the same.
Bravo! you are one of a kind, keep rocking!!!
Best video on 2d Grid Thank You for the explanation
Good stuff, for my dumb brain it wasn't clear in the first glance why we needed the nodes_in_next_layer and nodes_left_in_layer and how it's used. Had to replay and follow through the algorithm to understand its use.
Try to think this way: BFS is visiting graph layer by layer. Initially the nodes_left_in_layer = 1; supposed that there're 2 adjacent nodes (A, B)connecting the starting node(S), so the nodes_in_next_layer will be incremented to 2 after the explorer_neighbours(), then the nodes_left_in_layer is decremented to 0. Here, we reset the nodes_left_in_layer to 2 and nodes_in_next_layer to 0 and increment the move_count to 1. It means after visiting layer 1, we are expecting to visit 2 nodes in layer 2. We can image node A has 3 adjacent nodes (C, D, E) and node B has 1 adjacent nodes (F). Now try to go-thru layer 2 with the imaginary graph - we visit A, nodes_in_next_layer is set to 3, nodes_left_in_layer is set to 1, then visit B, nodes_in_next_layer is set to 4 and nodes_left_in_layer to 0. Here, we are finishing visit layer 2 and expecting to visit layer 3 with 4 coming nodes.
snap shots of queue:
(S)
(A) (B) // nodes_in_next_layer = 2, after visiting layer 1;
(B) (C) (D) (E) // pop (A) and push all neighbours (C) (D) (E)
(C) (D) (E) (F) // pop (B) and push neighbour (E)
// nodes_in_next_layer = 4, after visiting layer 2;
Hope this helps.
i think level would be better name compared to layer as BFS processes nodes which are at same level/distance from current node. Once we process all the nodes in current level, we move onto the next level. BFS is also called commonly referred to as level order traversal
@@jsarvesh yea, level is a much better name. I also find easier to code and understand passing an additional information into the object/struct of the queue, that is the level so when i push neighbors to the queue i increment this level/distance like this:
q.push((position){.level=nextLevel, .row=nextRow, .col=nextCol, .distance=pos.distance + 1});
Thank you so much! You definitely have talent in explaining!
This is amazing ♥️
Please keep solving that kind of problems ♥️♥️😍
A fellow student from hyperskill, psted your video link. On the lee algorithm course conent.
It is helpful.
This helped me so much you don't even know TYSM
Thank you so much for simplifying it
Awesome video, thank you so much!
Such a great explanation!!
Спасибо вам, за хорошее объяснение
Great buddy! Got it in the first go!
Now that I know the shortest path in value. How do i highlight the path it took.
I didnt understand how r u calculating nodes left in layer and nodes in next layer
Same
I also use two int arrays instead of an array of int,int objects. Before I was shy to tell about it because it is "not OOP". Now my design is backed by this video.
Thank you very much. It helped me a lot.
Thank you very much sir!!
Thank you.. this is helpful for making games as well
Amazing tutorial! Keep filming please :)
Quality content. Really appreciate it👍
thank you so much for these videos!
what is the time complexity for this?
Amazing video! Thanks a ton!
Awesome video!!! Thanks bro!
What do you mean by a 'layer'? (I am sorry if I missed it but I think its missing from the video)
Good explanation, thanks a lot
Thanks for the multiple queue trick. Storing them as pairs does not scale well to higher dimensions and p.first and p.second looks really ugly and ambiguous.
Could anyone explain what is the use of 'nodes_left_in_layer' and 'nodes_in_next_layer' variables?
Great tutorial! Congrats
Brilliant ! Thank you :)
I created a ArrayList variable to store the steps taken, but it store all the block the BFS explored instead of the green block that shown in the video.
How can I only store the shortest block need to be explored only?
keep with the good job!
Your videos are amazing, really!
Can I know where do you run your animations, please?
They're slides. Linked them in the description.
Man, wish I could see this before. Encountered this same problem in my First Round of Google Interview For Software Engineer.
Dude, their on site is all day variations of BFS problems, there's no hope lol
@@kickhuggy really? thats actually pretty cool lol
8:36 I understand the "Fill" method to get all the tiles, yet how are you getting this path from that ?
What about the Robot Vacuum Cleaner problem, a double array 3x3 a robot is somewhere in the grid and in some cells there is dirt and the robot must find the optimal path in order to clean the cells and doing that with the BFS algorithm. Any suggestions?
what happen if we are allowed to go in 8 direction diagonal also included then i think only BFS will not work anybody??
This guy is insane
How is it possible to get returned the coords for the path? I dont think the queue in the end contains the path or my implementation is wrong.
I don't understand the nodes left in layer and nodes in next layer part. Can someone link to a C++ solution to this problem using STL?
for the dungeon problem, why do we have to use bfs? why not dfs?
How do we know that this algorithm gives the shortest path ?
Am I the only one who missed the part where we select the path that he colored in green? What's explained in this video only shows how many steps we need to reach the end, but not the actual path.
is there a related leetcode problem to practice?
thanks it s really great bt how can I get the source code for this?
THANK YOU!
I have one question about these can you help me please
hey could we get the complete source code file?
how do you show the path once its done?
11:16 does this pseudo code applies for a 3d grid graph? im confused you mention to use 3 queues for 3ds grid graph and then went straight back to 2d pseudo code
8:55 how do we find the number of steps without tracing the path itself?
Your videos are amazing, but how do I get the short path if reached end ?, because my move_count data has already been calculated
can someone please help me understand, why is it we choose BFS over DFS to find "shortest path" ? i believe it has to be the way BFS traverses a graph as compared to DFS, but looking for a better explanation
Hi, I have a (maybe so stupid question). BFS cannot use as a shortest path finding with weighted graph right? (it just work with unweight - or all the edge have the same priority). I am not sure about this because at the video Overview, you said it can be use as shortest path finding algorithms. (But to my knowlege, it is impossible). Maybe i got mistake, thanks.
Big like for you. Thanks a lot :))
4:30 Send this to somebody without context.
Used queue and showing Stack ... :(
what if we are allowed to take off one obstacle???
Hi William, shouldn't the move count be move_count+1(if reached_end is true) as we are breaking the loop and not incrementing move_count for the last layer(where end node was found)?
No. When reaching the layer containing the E, the step to get to that layer is already accounted for.
Thanks a lot
You are the best
Damn this was good
thanks ,,, that was helpfull
Can you please share the link for the code, not able to find in your github link
I think there's only the pseudo code I show in this video. The previous video explaining generalized BFS has code though :)
Are you the same guy from freecodecamp video?
may i have a code plz
where can if find the video about tracing back the path?
I guess you're talking about backtracking technique which is used in the DFS method of maze solving
انت وحش حقيقي
Notable
Looking at the order of direction vectors which is (-1,0), (+1,0), (0,+1), (0, -1)...it looks like you are interested to move row wise first and then column wise. Then how does it become breadth first algorithm. As BFA says, we to move across the row first right.
Hi Shiva, it doesn't matter which direction vector is applied first because you're doing the BFS layer by layer and adding newly discovered nodes to the end of the queue.
That's exactly is my question.. how does this approach taking breadth first. With the use of vectors we go on finding the next node to traverse and looking at the these vectors, traversing need not be breadth wise. Because you are looking for next node above and below the current node first. I hope it makes sense.
Let me try and make this as clear as possible. For any given node, we add all the neighbors of that node to the list of nodes that need to be visited (unless the neighboring node has already been visited, is not traversable or something weird). The list of nodes to be visited is stored in a queue data structure. The queue has the property that the most recent node added to the queue is found at the end and the oldest node which has been in the queue the longest at the beginning. This means that we can add nodes to the queue and know that they will eventually get processed at a later stage. When the BFS starts you add the starting node to the queue to indicate that it should be visited. The algorithm begins by dequeuing (removing) the start node from the beginning of the queue, after which you add the left, right, down and up neighbors of the start node to the queue in that order (which shouldn't matter). Then the starting node's left node is first in the queue, so you add its left, right, down and up neighbors to the queue, then the starting node's right node if first in the queue, so you add its left, right, down and up neighbors to the queue, and etc... So the algorithm circles around if you will and the graph is explored layer by layer
Thanks for the detailed explanation ....
But it is better to keep everything in one queue due to cache efficiency and you could just use a struct Point{int x; int y;};
Nice tutorial tho